import * as Minecraft from "@minecraft/server"
import * as MinecraftUi from "@minecraft/server-ui"

var cooldown = {}

//Made by DerCoderJo
Minecraft.world.events.itemUseOn.subscribe((data) => {
    if(cooldown[data.source.name] == true) return
    
    cooldown[data.source.name] = true
    let player = data.source
    Minecraft.system.runTimeout(() => {
        cooldown[player.name] = false
    }, 10)

    if(data.source.typeId !== "minecraft:player" || data.source.isSneaking) return
    
    if(data.source.dimension.getBlock(data.getBlockLocation()).typeId.includes("stairs") && Minecraft.world.scoreboard.getObjective("sitOnStairs:data").getScore(Minecraft.world.scoreboard.getParticipants().find(pT => pT.displayName == "seat:All Stairs")) == 1){
        try{data.source.runCommandAsync(`summon sit:seat ${data.getBlockLocation().x} ${data.getBlockLocation().y += 0.35} ${data.getBlockLocation().z}`)
        data.source.runCommandAsync(`ride @s start_riding @r[x=${data.getBlockLocation().x}, y=${data.getBlockLocation().y}, z=${data.getBlockLocation().z}, type=sit:seat]`)}catch(err){console.error(err)}
    }else if(data.source.dimension.getBlock(data.getBlockLocation()).typeId.includes("slab") && Minecraft.world.scoreboard.getObjective("sitOnStairs:data").getScore(Minecraft.world.scoreboard.getParticipants().find(pT => pT.displayName == "seat:All Slabs")) == 1){
        data.source.runCommandAsync(`summon sit:seat ${data.getBlockLocation().x} ${data.getBlockLocation().y += 0.35} ${data.getBlockLocation().z}`)
        data.source.runCommandAsync(`ride @s start_riding @r[x=${data.getBlockLocation().x}, y=${data.getBlockLocation().y}, z=${data.getBlockLocation().z}, type=sit:seat]`)
    }else for(let seat of Minecraft.world.scoreboard.getObjective("sitOnStairs:data").getScores()) if(seat.participant.displayName.startsWith("seatId")){
        if(Minecraft.world.scoreboard.getObjective("sitOnStairs:data").getScore(Minecraft.world.scoreboard.getParticipants().find(pT => pT.displayName == seat.participant.displayName)) >= 1 && data.source.dimension.getBlock(data.getBlockLocation()).typeId == seat.participant.displayName.replace("seatId:", "")){
            data.source.runCommandAsync(`summon sit:seat ${data.getBlockLocation().x} ${data.getBlockLocation().y += Minecraft.world.scoreboard.getObjective("sitOnStairs:data").getScore(Minecraft.world.scoreboard.getParticipants().find(pT => pT.displayName == `height:${seat.participant.displayName.replace("seatId:", "")}`)) / 10} ${data.getBlockLocation().z}`)
            data.source.runCommandAsync(`ride @s start_riding @r[x=${data.getBlockLocation().x}, y=${data.getBlockLocation().y}, z=${data.getBlockLocation().z}, type=sit:seat]`)
        }
    }
})
//Made by DerCoderJo
Minecraft.system.run(async function tick(){
    Minecraft.system.run(tick)


    try{
        data.source.runCommandAsync(`scoreboard objectives add sitOnStairs:data dummy "Sit On Stairs - Data"`)
        data.source.runCommandAsync(`scoreboard players set "seat:All Stairs" sitOnStairs:data 1`)
        data.source.runCommandAsync(`scoreboard players set "seat:All Slabs" sitOnStairs:data 1`)
    }catch{}

    for(let entity of Minecraft.world.getDimension("overworld").getEntities()) if(entity?.typeId == "sit:seat"){
        let playerNear = false
        entity.runCommandAsync(`testfor @a[r=1]`).then((res) => {
            if(res.successCount >= 1) playerNear = true
        })
        Minecraft.system.runTimeout(() => {if(!playerNear) entity.kill()}, 1)
    }

    for(let player of Minecraft.world.getPlayers()) if(player.hasTag("sitOnStairs:settings")){
        player.removeTag("sitOnStairs:settings")
        
        new MinecraftUi.ActionFormData()
        .title("§r§7Sit on Stairs §8- §7Settings§r")
        .button("Seats")
        .show(player).then((res) => {
            if(res.isCanceled) return

            if(res.selection == 0){
                let buttons = []
                let form = new MinecraftUi.ActionFormData()

                for(let data of Minecraft.world.scoreboard.getObjective("sitOnStairs:data").getScores()) if(data.participant.displayName.startsWith("seat")){
                    let activated = Minecraft.world.scoreboard.getObjective("sitOnStairs:data").getScore(Minecraft.world.scoreboard.getParticipants().find(pT => pT.displayName == data.participant.displayName))
                    buttons.push({value: `§r§8${data.participant.displayName.replace("seat:", "").replace("seatId:", "")}§r\n${`§7Activated: ${activated}`.replace("0", "§cFalse§r").replace("1", "§aTrue§r")}`, activated: activated, id: data.participant.displayName})
                }
                buttons.push({value: "Add new Seat"})

                for(let button of buttons) form.button(button.value)
                form.show(player).then((res) => {
                    if(res.isCanceled) return
                    let selection = buttons[res.selection]
                    if(selection.value == "Add new Seat"){
                        new MinecraftUi.ModalFormData()
                        .title("§r§7Sit on Stairs §8- §7Settings §8- §7Add new Seat§r")
                        //.body("Made by DerCoderJo")
                        .textField("Block ID", "minecraft:stone")
                        .slider("Height", 0, 10, 1)
                        .show(player).then((res) => {
                            player.runCommandAsync(`scoreboard players set "seatId:${res.formValues[0]}" sitOnStairs:data 1`)
                            player.runCommandAsync(`scoreboard players set "height:${res.formValues[0]}" sitOnStairs:data ${res.formValues[1]}`)
                        })
                    }else{
                        if(selection.activated <= 0) selection.activated = false
                        else selection.activated = true

                        let modal = new MinecraftUi.ModalFormData()
                        .title(`§r§8Sit on Stairs §7- §8Settings §7- ${selection.value.split("\n")[0]}§r`)
                        .toggle("Activated", selection.activated)
                        if(!selection.id.startsWith("seat:")){
                            modal.slider("Height", 0, 10, 1, parseInt(String(Minecraft.world.getDimension("overworld").runCommandAsync(`scoreboard players test "height:${selection.id.replace("seatId:", "")}" "sitOnStairs:data" *`).statusMessage?.split(" ")[1]), 10))
                        }
                        modal.show(player).then((res) => {
                            if(res.isCanceled) return

                            if(res?.formValues[0]) player.runCommandAsync(`scoreboard players set "${selection.id}" sitOnStairs:data 1`)
                            else player.runCommandAsync(`scoreboard players set "${selection.id}" sitOnStairs:data 0`)
                            if(res?.formValues[1]) player.runCommandAsync(`scoreboard players set "height:${selection.id.replace("seatId:").replace("undefined", "")}" sitOnStairs:data ${res.formValues[1]}`)
                        })
                    }
                })
            }
        })
    }
})

Minecraft.system.events.beforeWatchdogTerminate.subscribe((data) => data.cancel = true)